' Snowflakes
' By Ted Felix
' Copyright 2003, Ted Felix, All Rights Reserved

' Like real snowflakes, each one is unique.

' I remember this program from the TRS-80.  I think it may have been part
' of a larger winter themed program that put up a series of pretty pictures
' including a snow scene and that Robert Frost poem.  I'm guessing that
' I probably typed it in from "80 Micro" or "Creative Computing" magazine.
' This is a complete reinterpretation of the program, using polar
' coordinates.

' 12/1980? or 12/1981? - Typed in the original from a magazine?
' 12/1985?  - Ported from TRS-80 to BASICA.
' 11/4/1995 - Rewrote this in QBASIC using polar coordinates.
'  2/4/2003 - Polished it up, made the PolarLine() SUB.

DECLARE SUB PolarLine (r1!, t1!, r2!, t2!)

RANDOMIZE TIMER

SCREEN 12
CONST XRange = 640
CONST YRange = 480

CONST XCenter = XRange / 2
CONST YCenter = YRange / 2
CONST Pi3! = 3.141592 / 3  ' 60 degrees
CONST RLimit = YCenter

DO
  CLS
  ' Get the number of lines in the snowflake
  Total = RND * 15 + 5

  ' For each line
  FOR Count = 1 TO Total

    ' Pick two random points in polar coordinates
    r1 = RND * RLimit
    t1 = RND * Pi3!
    r2 = RND * RLimit
    t2 = RND * Pi3!

    ' Compute the mirror image of those points in the 60 degree sector
    mt1 = Pi3! - t1
    mt2 = Pi3! - t2

    ' For each 60 degree sector around the circle
    FOR I = 0 TO 5
      ' Draw the line
      CALL PolarLine(r1, t1 + (I * Pi3!), r2, t2 + (I * Pi3!))

      ' Draw the mirror image line within the 60 degree sector
      CALL PolarLine(r1, mt1 + (I * Pi3!), r2, mt2 + (I * Pi3!))
    NEXT I

  NEXT Count
 
  ' Wait 5 seconds
  t = TIMER
  DO
  LOOP UNTIL TIMER > t + 5

LOOP WHILE INKEY$ = ""

SUB PolarLine (r1!, t1!, r2!, t2!)
  ' Draws a line between two points in polar coordinates.
  '   r1! - R for the first point
  '   t1! - Theta for the first point
  '   r2! - R for the second point
  '   t2! - Theta for the second point

  ' Apparently, CONST objects have global scope, so there's no need
  ' to SHARED XCenter and YCenter.

  ' Convert to cartesian
  x1% = CINT(r1! * COS(t1!))
  y1% = CINT(r1! * SIN(t1!))
  x2% = CINT(r2! * COS(t2!))
  y2% = CINT(r2! * SIN(t2!))

  ' Draw the line
  LINE (x1% + XCenter, y1% + YCenter)-(x2% + XCenter, y2% + YCenter)
END SUB

